/**
 * @file
 * This header file declares the function to create one instance of the CrIaAcqFullDrop procedure.
 * The procedure is configured with a set of function pointers representing the non-default
 * actions and guards of the procedure. Some of these functions may also be declared in
 * this header file in accordance with the configuration of the procedure in the FW Profile
 * Editor. In the latter case, the user has to provide an implementation for these functions
 * in a user-supplied body file.
 *
 * This header file has been automatically generated by the FW Profile Editor.
 * The procedure created by this file is shown in the figure below.
 * @image html CrIaAcqFullDrop.png
 *
 * @author FW Profile code generator version 4.63
 * @date Created on: Jun 3 2016 19:48:4
 */

/** Make sure to include this header file only once */
#ifndef CrIaAcqFullDropCreate_H_
#define CrIaAcqFullDropCreate_H_

/** FW Profile function definitions */
#include "FwProfile/FwPrConstants.h"

/** Action node identifiers */
#define CrIaAcqFullDrop_N1 (1)		/* The identifier of action node N1 in procedure CrIaAcqFullDrop */
#define CrIaAcqFullDrop_N2 (2)		/* The identifier of action node N2 in procedure CrIaAcqFullDrop */
#define CrIaAcqFullDrop_N2_1 (3)		/* The identifier of action node N2_1 in procedure CrIaAcqFullDrop */
#define CrIaAcqFullDrop_N3 (4)		/* The identifier of action node N3 in procedure CrIaAcqFullDrop */
#define CrIaAcqFullDrop_N4 (5)		/* The identifier of action node N4 in procedure CrIaAcqFullDrop */
#define CrIaAcqFullDrop_N5 (6)		/* The identifier of action node N5 in procedure CrIaAcqFullDrop */
#define CrIaAcqFullDrop_N6 (7)		/* The identifier of action node N6 in procedure CrIaAcqFullDrop */
#define CrIaAcqFullDrop_N7 (8)		/* The identifier of action node N7 in procedure CrIaAcqFullDrop */
#define CrIaAcqFullDrop_N8 (9)		/* The identifier of action node N8 in procedure CrIaAcqFullDrop */
#define CrIaAcqFullDrop_N9 (10)		/* The identifier of action node N9 in procedure CrIaAcqFullDrop */
#define CrIaAcqFullDrop_N10 (11)		/* The identifier of action node N10 in procedure CrIaAcqFullDrop */
#define CrIaAcqFullDrop_N11 (12)		/* The identifier of action node N11 in procedure CrIaAcqFullDrop */
#define CrIaAcqFullDrop_N12 (13)		/* The identifier of action node N12 in procedure CrIaAcqFullDrop */
#define CrIaAcqFullDrop_N13 (14)		/* The identifier of action node N13 in procedure CrIaAcqFullDrop */

/** User-defined includes */
#include "FwProfile/FwPrCore.h"

/**
 * Create a new procedure descriptor.
 * This interface creates the procedure descriptor dynamically.
 * @param prData the pointer to the procedure data.
 * A value of NULL is legal (note that the default value of the pointer
 * to the procedure data when the procedure is created is NULL).
 * @return the pointer to the procedure descriptor
 */
FwPrDesc_t CrIaAcqFullDropCreate(void* prData);

/**
 * Action for node N4.
 * Send cmd (220,11) to SEM
 * @param smDesc the procedure descriptor
 */
void CrIaAcqFullDropN4(FwPrDesc_t prDesc);

/**
 * Action for node N5.
 * <pre>
 * Send command GoToCcdFull
 * to SEM Unit State Machine
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaAcqFullDropN5(FwPrDesc_t prDesc);

/**
 * Action for node N1.
 * <pre>
 * Generate Event Report
 * EVT_SC_PR_STRT
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaAcqFullDropN1(FwPrDesc_t prDesc);

/**
 * Action for node N10.
 * Stop Acquisition Algorithms
 * @param smDesc the procedure descriptor
 */
void CrIaAcqFullDropN10(FwPrDesc_t prDesc);

/**
 * Action for node N6.
 * Start Acquisition Algorithms
 * @param smDesc the procedure descriptor
 */
void CrIaAcqFullDropN6(FwPrDesc_t prDesc);

/**
 * Action for node N8.
 * <pre>
 * Evaluate Pointing Error on data in SIB
 * pointed at by sibOut and then increment sibOut
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaAcqFullDropN8(FwPrDesc_t prDesc);

/**
 * Action for node N12.
 * <pre>
 * Generate Event Report
 * EVT_SC_PR_END with
 * outcome equal to: "success"
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaAcqFullDropN12(FwPrDesc_t prDesc);

/**
 * Action for node N11.
 * <pre>
 * Send command GoToStabilize
 * to SEM Unit State Machine
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaAcqFullDropN11(FwPrDesc_t prDesc);

/**
 * Action for node N2.
 * <pre>
 * Update SEM configuration
 * parameters in data pool
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaAcqFullDropN2(FwPrDesc_t prDesc);

/**
 * Action for node N3.
 * Send cmd (220,3) to SEM
 * @param smDesc the procedure descriptor
 */
void CrIaAcqFullDropN3(FwPrDesc_t prDesc);

/**
 * Action for node N2_1.
 * <pre>
 * Set data pool variable
 * pCcdRdMode to CCD_FULL
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaAcqFullDropN2_1(FwPrDesc_t prDesc);

/**
 * Action for node N13.
 * <pre>
 * Load event 
 * EVT_ACQ_FAIL
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaAcqFullDropN13(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from N4 to N5.
 * <pre>
 *  Wait acqFullDropT2
 * cycles 
 * </pre>
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaAcqFullDropWaitT2(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from N1 to N2.
 *  SEM State Machine is in STABILIZE 
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaAcqFullDropIsSemInStab(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from DECISION8 to N10.
 * <pre>
 * Target acquisition
 * successfully completed 
 * </pre>
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaAcqFullDropIsTrgtAcq(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from DECISION8 to N13.
 * <pre>
 * Target acquisition
 * completed unsuccessfully 
 * </pre>
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaAcqFullDropIsTrgtNotAcq(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from N7 to N8.
 *  Acquisition of an image has completed 
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaAcqFullDropIsImgAcq(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from N11 to N12.
 * <pre>
 *  (SEM Operational SM is in STABILIZE) &&
 * (All sporadic activities have terminated)  
 * </pre>
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaAcqFullDropIsTerm(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from N3 to N4.
 * <pre>
 *  Wait acqFullDropT1
 * cycles 
 * </pre>
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaAcqFullDropWaitT1(FwPrDesc_t prDesc);

#endif /* CrIaAcqFullDropCreate_H_ */
