/**
 * @file
 * This header file declares the function to create one instance of the CrIaCtrldSwitchOff procedure.
 * The procedure is configured with a set of function pointers representing the non-default
 * actions and guards of the procedure. Some of these functions may also be declared in
 * this header file in accordance with the configuration of the procedure in the FW Profile
 * Editor. In the latter case, the user has to provide an implementation for these functions
 * in a user-supplied body file.
 *
 * This header file has been automatically generated by the FW Profile Editor.
 * The procedure created by this file is shown in the figure below.
 * @image html CrIaCtrldSwitchOff.png
 *
 * @author FW Profile code generator version 4.63
 * @date Created on: Feb 11 2016 22:56:46
 */

/** Make sure to include this header file only once */
#ifndef CrIaCtrldSwitchOffCreate_H_
#define CrIaCtrldSwitchOffCreate_H_

/** FW Profile function definitions */
#include "FwProfile/FwPrConstants.h"

/** Action node identifiers */
#define CrIaCtrldSwitchOff_N1 1		/* The identifier of action node N1 in procedure CrIaCtrldSwitchOff */
#define CrIaCtrldSwitchOff_N2 2		/* The identifier of action node N2 in procedure CrIaCtrldSwitchOff */

/**
 * Create a new procedure descriptor.
 * This interface creates the procedure descriptor dynamically.
 * @param prData the pointer to the procedure data.
 * A value of NULL is legal (note that the default value of the pointer
 * to the procedure data when the procedure is created is NULL).
 * @return the pointer to the procedure descriptor
 */
FwPrDesc_t CrIaCtrldSwitchOffCreate(void* prData);

/**
 * Action for node N1.
 * <pre>
 * Send StopSem Command
 * to IASW State Machine
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaCtrldSwitchOffStopSem(FwPrDesc_t prDesc);

/**
 * Action for node N2.
 * <pre>
 * Disable Error Log by
 * setting ERR_LOG_ENB to false
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaCtrldSwitchOffDisErrLog(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from N2 to Final Node.
 *  Wait CTRLD_SWITCH_OFF_T1 
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaCtrldSwitchOffWaitT1(FwPrDesc_t prDesc);

#endif /* CrIaCtrldSwitchOffCreate_H_ */