/**
 * @file
 * This header file declares the function to create one instance of the CrIaFbfSave procedure.
 * The procedure is configured with a set of function pointers representing the non-default
 * actions and guards of the procedure. Some of these functions may also be declared in
 * this header file in accordance with the configuration of the procedure in the FW Profile
 * Editor. In the latter case, the user has to provide an implementation for these functions
 * in a user-supplied body file.
 *
 * This header file has been automatically generated by the FW Profile Editor.
 * The procedure created by this file is shown in the figure below.
 * @image html CrIaFbfSave.png
 *
 * @author FW Profile code generator version 4.63
 * @date Created on: May 4 2016 8:24:50
 */

/** Make sure to include this header file only once */
#ifndef CrIaFbfSaveCreate_H_
#define CrIaFbfSaveCreate_H_

/** FW Profile function definitions */
#include "FwProfile/FwPrConstants.h"

/** Action node identifiers */
#define CrIaFbfSave_N1 1		/* The identifier of action node N1 in procedure CrIaFbfSave */
#define CrIaFbfSave_N2 2		/* The identifier of action node N2 in procedure CrIaFbfSave */
#define CrIaFbfSave_N3 3		/* The identifier of action node N3 in procedure CrIaFbfSave */
#define CrIaFbfSave_N4 4		/* The identifier of action node N4 in procedure CrIaFbfSave */
#define CrIaFbfSave_N5 5		/* The identifier of action node N5 in procedure CrIaFbfSave */
#define CrIaFbfSave_N6 6		/* The identifier of action node N6 in procedure CrIaFbfSave */

/**
 * Create a new procedure descriptor.
 * This interface creates the procedure descriptor dynamically.
 * @param prData the pointer to the procedure data.
 * A value of NULL is legal (note that the default value of the pointer
 * to the procedure data when the procedure is created is NULL).
 * @return the pointer to the procedure descriptor
 */
FwPrDesc_t CrIaFbfSaveCreate(void* prData);

/**
 * Action for node N2.
 * <pre>
 * Call IBSW operation to transfer 
 * the first block from RAM Data Area
 * to the Target FBF
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaFbfSaveN2(FwPrDesc_t prDesc);

/**
 * Action for node N3.
 * <pre>
 * Call IBSW operation to transfer 
 * the next block from RAM Data Area
 * to the Target FBF
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaFbfSaveN3(FwPrDesc_t prDesc);

/**
 * Action for node N1.
 * <pre>
 * Call IBSW operation
 * to open the Target FBF
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaFbfSaveN1(FwPrDesc_t prDesc);

/**
 * Action for node N4.
 * <pre>
 * Call IBSW operation
 * to close the Target FBF
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaFbfSaveN4(FwPrDesc_t prDesc);

/**
 * Action for node N5.
 * <pre>
 * Load EVT_FBF_SAVE_DENIED
 * with FBF identifier as parameter
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaFbfSaveN5(FwPrDesc_t prDesc);

/**
 * Action for node N6.
 * <pre>
 * Load EVT_FBF_SAVE_ABRT
 * with FBF identifier and number
 * of blocks written as parameters
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaFbfSaveN6(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from N2 to DECISION1.
 *  Wait FBF_BLCK_WR_DUR Cycles 
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaFbfSaveWaitFbfBlckWrDur(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from DECISION1 to N3.
 * <pre>
 *  (Not all requested blocks 
 * have been written) && !Flag_1 
 * </pre>
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaFbfSaveToN3(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from DECISION2 to N1.
 *  ! Flag_1 
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaFbfSaveFlag1(FwPrDesc_t prDesc);

#endif /* CrIaFbfSaveCreate_H_ */