/**
 * @file
 * This header file declares the function to create one instance of the CrIaPrgAct6s2 procedure.
 * The procedure is configured with a set of function pointers representing the non-default
 * actions and guards of the procedure. Some of these functions may also be declared in
 * this header file in accordance with the configuration of the procedure in the FW Profile
 * Editor. In the latter case, the user has to provide an implementation for these functions
 * in a user-supplied body file.
 *
 * This header file has been automatically generated by the FW Profile Editor.
 * The procedure created by this file is shown in the figure below.
 * @image html CrIaPrgAct6s2.png
 *
 * @author FW Profile code generator version 4.63
 * @date Created on: Feb 11 2016 22:56:45
 */

/** Make sure to include this header file only once */
#ifndef CrIaPrgAct6s2Create_H_
#define CrIaPrgAct6s2Create_H_

/** FW Profile function definitions */
#include "FwProfile/FwPrConstants.h"

/** Action node identifiers */
#define CrIaPrgAct6s2_MEMLOAD1 1		/* The identifier of action node MEMLOAD1 in procedure CrIaPrgAct6s2 */
#define CrIaPrgAct6s2_MEMLOAD2 2		/* The identifier of action node MEMLOAD2 in procedure CrIaPrgAct6s2 */
#define CrIaPrgAct6s2_MEMLOAD3 3		/* The identifier of action node MEMLOAD3 in procedure CrIaPrgAct6s2 */
#define CrIaPrgAct6s2_MEMLOAD4 4		/* The identifier of action node MEMLOAD4 in procedure CrIaPrgAct6s2 */

/**
 * Create a new procedure descriptor.
 * This interface creates the procedure descriptor dynamically.
 * @param prData the pointer to the procedure data.
 * A value of NULL is legal (note that the default value of the pointer
 * to the procedure data when the procedure is created is NULL).
 * @return the pointer to the procedure descriptor
 */
FwPrDesc_t CrIaPrgAct6s2Create(void* prData);

/**
 * Action for node MEMLOAD1.
 * Patch data to their destination 
 * @param smDesc the procedure descriptor
 */
void CrIaPrgAct6s2PatchData(FwPrDesc_t prDesc);

/**
 * Action for node MEMLOAD2.
 * Read back patched data 
 * @param smDesc the procedure descriptor
 */
void CrIaPrgAct6s2ReadData(FwPrDesc_t prDesc);

/**
 * Action for node MEMLOAD3.
 * <pre>
 * 
 * Set action outcome to "completed"
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaPrgAct6s2Completed(FwPrDesc_t prDesc);

/**
 * Action for node MEMLOAD4.
 * <pre>
 * 
 * Set action outcome to "failed"
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaPrgAct6s2Failed(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from DECISION1 to MEMLOAD3.
 *  Read-Back Data are Correct 
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaPrgAct6s2IsReadDataCorrect(FwPrDesc_t prDesc);

#endif /* CrIaPrgAct6s2Create_H_ */