/**
 * @file
 * This header file declares the function to create one instance of the CrIaSciDataUpd procedure.
 * The procedure is configured with a set of function pointers representing the non-default
 * actions and guards of the procedure. Some of these functions may also be declared in
 * this header file in accordance with the configuration of the procedure in the FW Profile
 * Editor. In the latter case, the user has to provide an implementation for these functions
 * in a user-supplied body file.
 *
 * This header file has been automatically generated by the FW Profile Editor.
 * The procedure created by this file is shown in the figure below.
 * @image html CrIaSciDataUpd.png
 *
 * @author FW Profile code generator version 4.63
 * @date Created on: Feb 11 2016 22:56:45
 */

/** Make sure to include this header file only once */
#ifndef CrIaSciDataUpdCreate_H_
#define CrIaSciDataUpdCreate_H_

/** FW Profile function definitions */
#include "FwProfile/FwPrConstants.h"

/** Action node identifiers */
#define CrIaSciDataUpd_N1 1		/* The identifier of action node N1 in procedure CrIaSciDataUpd */
#define CrIaSciDataUpd_N2 2		/* The identifier of action node N2 in procedure CrIaSciDataUpd */
#define CrIaSciDataUpd_N3 3		/* The identifier of action node N3 in procedure CrIaSciDataUpd */
#define CrIaSciDataUpd_N4 4		/* The identifier of action node N4 in procedure CrIaSciDataUpd */
#define CrIaSciDataUpd_N5 5		/* The identifier of action node N5 in procedure CrIaSciDataUpd */

/**
 * Create a new procedure descriptor.
 * This interface creates the procedure descriptor dynamically.
 * @param prData the pointer to the procedure data.
 * A value of NULL is legal (note that the default value of the pointer
 * to the procedure data when the procedure is created is NULL).
 * @return the pointer to the procedure descriptor
 */
FwPrDesc_t CrIaSciDataUpdCreate(void* prData);

/**
 * Action for node N2.
 * Generate Event EVT_SDSC_ILL
 * @param smDesc the procedure descriptor
 */
void CrIaSciDataUpdN2(FwPrDesc_t prDesc);

/**
 * Action for node N3.
 * Generate Event EVT_SDSC_OOS
 * @param smDesc the procedure descriptor
 */
void CrIaSciDataUpdN3(FwPrDesc_t prDesc);

/**
 * Action for node N5.
 * Store science data in SIB
 * @param smDesc the procedure descriptor
 */
void CrIaSciDataUpdN5(FwPrDesc_t prDesc);

/**
 * Action for node N4.
 * Generate Event EVT_SIB_SIZE
 * @param smDesc the procedure descriptor
 */
void CrIaSciDataUpdN4(FwPrDesc_t prDesc);

/**
 * Action for node N1.
 * <pre>
 * Increment sibIn
 * and initialize header
 * information for new image
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaSciDataUpdN1(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from DECISION1 to DECISION2.
 * <pre>
 *  SDSC has
 * legal value 
 * </pre>
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaSciDataUpdHasSdscLegalVal(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from DECISION2 to N3.
 *  SDSC is out-of-sequence 
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaSciDataUpdIsSdscOutOfSeq(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from DECISION3 to N4.
 * <pre>
 *  SIB is too small to hold
 * new batch of science data 
 * </pre>
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaSciDataUpdIsSibTooSmall(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from DECISION4 to N1.
 *  Flag_1 
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaSciDataUpdFlag1(FwPrDesc_t prDesc);

#endif /* CrIaSciDataUpdCreate_H_ */