/**
 * @file
 * This header file declares the function to create one instance of the CrIaSciWin procedure.
 * The procedure is configured with a set of function pointers representing the non-default
 * actions and guards of the procedure. Some of these functions may also be declared in
 * this header file in accordance with the configuration of the procedure in the FW Profile
 * Editor. In the latter case, the user has to provide an implementation for these functions
 * in a user-supplied body file.
 *
 * This header file has been automatically generated by the FW Profile Editor.
 * The procedure created by this file is shown in the figure below.
 * @image html CrIaSciWin.png
 *
 * @author FW Profile code generator version 5.01
 * @date Created on: Jul 16 2018 16:41:56
 */

/** Make sure to include this header file only once */
#ifndef CrIaSciWinCreate_H_
#define CrIaSciWinCreate_H_

/** FW Profile function definitions */
#include "FwProfile/FwPrConstants.h"

/** Action node identifiers */
#define CrIaSciWin_N1 (1)		/* The identifier of action node N1 in procedure CrIaSciWin */
#define CrIaSciWin_N2 (2)		/* The identifier of action node N2 in procedure CrIaSciWin */
#define CrIaSciWin_N3 (3)		/* The identifier of action node N3 in procedure CrIaSciWin */
#define CrIaSciWin_N4 (4)		/* The identifier of action node N4 in procedure CrIaSciWin */
#define CrIaSciWin_N5 (5)		/* The identifier of action node N5 in procedure CrIaSciWin */
#define CrIaSciWin_N5_1 (6)		/* The identifier of action node N5_1 in procedure CrIaSciWin */
#define CrIaSciWin_N5_2 (7)		/* The identifier of action node N5_2 in procedure CrIaSciWin */
#define CrIaSciWin_N6 (8)		/* The identifier of action node N6 in procedure CrIaSciWin */
#define CrIaSciWin_N8 (9)		/* The identifier of action node N8 in procedure CrIaSciWin */
#define CrIaSciWin_N9 (10)		/* The identifier of action node N9 in procedure CrIaSciWin */
#define CrIaSciWin_N10 (11)		/* The identifier of action node N10 in procedure CrIaSciWin */

/**
 * Create a new procedure descriptor.
 * This interface creates the procedure descriptor dynamically.
 * @param prData the pointer to the procedure data.
 * A value of NULL is legal (note that the default value of the pointer
 * to the procedure data when the procedure is created is NULL).
 * @return the pointer to the procedure descriptor
 */
FwPrDesc_t CrIaSciWinCreate(void* prData);

/**
 * Action for node N4.
 * Send cmd (220,11) to SEM
 * @param smDesc the procedure descriptor
 */
void CrIaSciWinN4(FwPrDesc_t prDesc);

/**
 * Action for node N5.
 * <pre>
 * Send command GoToCcdWindow
 * to SEM Unit State Machine
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaSciWinN5(FwPrDesc_t prDesc);

/**
 * Action for node N1.
 * <pre>
 * Generate Event Report
 * EVT_SC_PR_STRT
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaSciWinN1(FwPrDesc_t prDesc);

/**
 * Action for node N9.
 * <pre>
 * Stop Compression/Collection
 * and Centroiding Algorithms
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaSciWinN9(FwPrDesc_t prDesc);

/**
 * Action for node N10.
 * <pre>
 * Generate Event Report
 * EVT_SC_PR_END with
 * outcome equal to: "success"
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaSciWinN10(FwPrDesc_t prDesc);

/**
 * Action for node N8.
 * <pre>
 * Send command GoToStabilize
 * to SEM Unit State Machine
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaSciWinN8(FwPrDesc_t prDesc);

/**
 * Action for node N2.
 * <pre>
 * Update SEM configuration
 * parameters in the data pool
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaSciWinN2(FwPrDesc_t prDesc);

/**
 * Action for node N3.
 * Send cmd (220,3) to SEM
 * @param smDesc the procedure descriptor
 */
void CrIaSciWinN3(FwPrDesc_t prDesc);

/**
 * Action for node N6.
 * <pre>
 * Start Compression/Collection
 * Algorithm
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaSciWinN6(FwPrDesc_t prDesc);

/**
 * Action for node N5_1.
 * <pre>
 * Enable selected
 * centroiding algorithm
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaSciWinN5_1(FwPrDesc_t prDesc);

/**
 * Action for node N5_2.
 * Start Centroiding Algorithms
 * @param smDesc the procedure descriptor
 */
void CrIaSciWinN5_2(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from N4 to N5.
 *  Wait sciWinStackT2 cycles 
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaSciWinWaitT2(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from N1 to N2.
 *  SEM State Machine is in STABILIZE 
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaSciWinIsSemInStab(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from N9 to N10.
 * <pre>
 *  (SEM Operational SM is in STABILIZE) &&
 * (All sporadic activities have terminated) 
 * </pre>
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaSciWinIsTerm(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from N3 to N4.
 * Wait sciWinStackT1 cycles 
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaSciWinWaitT1(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from N6 to N8.
 *  Flag_1 
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaSciWinFlag1And2(FwPrDesc_t prDesc);

#endif /* CrIaSciWinCreate_H_ */
