/**
 * @file
 * This header file declares the function to create one instance of the CrIaSemConsCheck procedure.
 * The procedure is configured with a set of function pointers representing the non-default
 * actions and guards of the procedure. Some of these functions may also be declared in
 * this header file in accordance with the configuration of the procedure in the FW Profile
 * Editor. In the latter case, the user has to provide an implementation for these functions
 * in a user-supplied body file.
 *
 * This header file has been automatically generated by the FW Profile Editor.
 * The procedure created by this file is shown in the figure below.
 * @image html CrIaSemConsCheck.png
 *
 * @author FW Profile code generator version 5.01
 * @date Created on: Dec 7 2017 0:24:42
 */

/** Make sure to include this header file only once */
#ifndef CRIASEMCONSCHECK_H_
#define CRIASEMCONSCHECK_H_

/** FW Profile function definitions */
#include "FwPrConstants.h"

/** Action node identifiers */
#define CrIaSemConsCheck_N1 (1)		/* The identifier of action node N1 in procedure CrIaSemConsCheck */
#define CrIaSemConsCheck_N2 (2)		/* The identifier of action node N2 in procedure CrIaSemConsCheck */
#define CrIaSemConsCheck_N3 (3)		/* The identifier of action node N3 in procedure CrIaSemConsCheck */

typedef struct {
  unsigned char anomaly;
} prDescSemConsFdCheck_t;

/**
 * Create a new procedure descriptor.
 * This interface creates the procedure descriptor statically.
 * It creates a single static instance of the procedure.
 * The function should only be called once.
 * If it is called several times, it always reconfigures and returns the same instance.
 * @param prData the pointer to the procedure data.
 * A value of NULL is legal (note that the default value of the pointer
 * to the procedure data when the procedure is created is NULL).
 * @return the pointer to the procedure descriptor
 */
FwPrDesc_t CrIaSemConsCheckCreate(void* prData);

/**
 * Action for node N1.
 * <pre>
 * semMode = SEM mode as given in the
 * latest SEM Default Housekeeping Packet
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaSemConsCheckN1(FwPrDesc_t prDesc);

/**
 * Action for node N3.
 * Return No Anomaly
 * @param smDesc the procedure descriptor
 */
void CrIaSemConsCheckN3(FwPrDesc_t prDesc);

/**
 * Action for node N2.
 * Return Anomaly Detected
 * @param smDesc the procedure descriptor
 */
void CrIaSemConsCheckN2(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from DECISION2 to N3.
 * <pre>
 * SEM Operational State Machine
 * is in a TR_* State 
 * </pre>
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaSemConsCheckTrState(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from DECISION3 to N3.
 * <pre>
 * State of SEM Operational State
 * Machine is the same as semState 
 * </pre>
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaSemConsCheckSemState(FwPrDesc_t prDesc);

#endif /* CrIaSemConsCheckCreate_H_ */