/**
 * @file
 * This header file declares the function to create one instance of the CrIaSemHkUpdPr procedure.
 * The procedure is configured with a set of function pointers representing the non-default
 * actions and guards of the procedure. Some of these functions may also be declared in
 * this header file in accordance with the configuration of the procedure in the FW Profile
 * Editor. In the latter case, the user has to provide an implementation for these functions
 * in a user-supplied body file.
 *
 * This header file has been automatically generated by the FW Profile Editor.
 * The procedure created by this file is shown in the figure below.
 *
 * <b>Note for node N1</b>
 * This function knows the mapping of the 
 * parameters in the two SEM housekeeping 
 * reports to parameters in the data pool. 
 * The report's time-stamp is also copied to the 
 * data pool.
 *
 * <b>Note for node N2</b>
 * If pckt is the packet holding the report to be forwarded,
 * this function uses function CrFwOutStreamSend on 
 * OutStreamGrd (the OutStream managing packets 
 * going to the ground) to re-route the packet to the ground.
 *
 * @image html CrIaSemHkUpdPr.png
 *
 * @author FW Profile code generator version 4.63
 * @date Created on: Feb 11 2016 22:56:45
 */

/** Make sure to include this header file only once */
#ifndef CrIaSemHkUpdPrCreate_H_
#define CrIaSemHkUpdPrCreate_H_

/** FW Profile function definitions */
#include "FwProfile/FwPrConstants.h"

/** Action node identifiers */
#define CrIaSemHkUpdPr_N1 1		/* The identifier of action node N1 in procedure CrIaSemHkUpdPr */
#define CrIaSemHkUpdPr_N2 2		/* The identifier of action node N2 in procedure CrIaSemHkUpdPr */

/**
 * Create a new procedure descriptor.
 * This interface creates the procedure descriptor dynamically.
 * @param prData the pointer to the procedure data.
 * A value of NULL is legal (note that the default value of the pointer
 * to the procedure data when the procedure is created is NULL).
 * @return the pointer to the procedure descriptor
 */
FwPrDesc_t CrIaSemHkUpdPrCreate(void* prData);

/**
 * Action for node N1.
 * Copy HK report to Data Pool
 * @param smDesc the procedure descriptor
 */
void CrIaSemHkUpdPrCopy(FwPrDesc_t prDesc);

/**
 * Action for node N2.
 * Forward HK report to Ground
 * @param smDesc the procedure descriptor
 */
void CrIaSemHkUpdPrForward(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from DECISION1 to N2.
 *  Flag_1 
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaSemHkUpdPrFlag1(FwPrDesc_t prDesc);

#endif /* CrIaSemHkUpdPrCreate_H_ */