/**
 * @file
 * This header file declares the function to create one instance of the CrIaSemShutdown procedure.
 * The procedure is configured with a set of function pointers representing the non-default
 * actions and guards of the procedure. Some of these functions may also be declared in
 * this header file in accordance with the configuration of the procedure in the FW Profile
 * Editor. In the latter case, the user has to provide an implementation for these functions
 * in a user-supplied body file.
 *
 * This header file has been automatically generated by the FW Profile Editor.
 * The procedure created by this file is shown in the figure below.
 * @image html CrIaSemShutdown.png
 *
 * @author FW Profile code generator version 4.63
 * @date Created on: Jun 3 2016 19:48:4
 */

/** Make sure to include this header file only once */
#ifndef CrIaSemShutdownCreate_H_
#define CrIaSemShutdownCreate_H_

/** FW Profile function definitions */
#include "FwProfile/FwPrConstants.h"

/** Action node identifiers */
#define CrIaSemShutdown_N1 (1)		/* The identifier of action node N1 in procedure CrIaSemShutdown */
#define CrIaSemShutdown_N2 (2)		/* The identifier of action node N2 in procedure CrIaSemShutdown */

/**
 * Create a new procedure descriptor.
 * This interface creates the procedure descriptor dynamically.
 * @param prData the pointer to the procedure data.
 * A value of NULL is legal (note that the default value of the pointer
 * to the procedure data when the procedure is created is NULL).
 * @return the pointer to the procedure descriptor
 */
FwPrDesc_t CrIaSemShutdownCreate(void* prData);

/**
 * Action for node N1.
 * <pre>
 * Open External SEM Power Switch
 * and FPM Heater Power Switch
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaSemShutdownOpenSwitch(FwPrDesc_t prDesc);

/**
 * Action for node N2.
 * Send CMD_Standby_Enter to SEM
 * @param smDesc the procedure descriptor
 */
void CrIaSemShutdownN2(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from N1 to Final Node.
 *  Wait SEM_SHUTDOWN_T2 
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaSemShutdownWaitT2(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from N2 to N1.
 *  Flag_1 || Flag_2 
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaSemShutdownAfterN2(FwPrDesc_t prDesc);

#endif /* CrIaSemShutdownCreate_H_ */
