/**
 * @file
 * This header file declares the function to create one instance of the CrIaTransferFbfToGround procedure.
 * The procedure is configured with a set of function pointers representing the non-default
 * actions and guards of the procedure. Some of these functions may also be declared in
 * this header file in accordance with the configuration of the procedure in the FW Profile
 * Editor. In the latter case, the user has to provide an implementation for these functions
 * in a user-supplied body file.
 *
 * This header file has been automatically generated by the FW Profile Editor.
 * The procedure created by this file is shown in the figure below.
 * @image html CrIaTransferFbfToGround.png
 *
 * @author FW Profile code generator version 4.63
 * @date Created on: Jun 3 2016 19:48:4
 */

/** Make sure to include this header file only once */
#ifndef CrIaTransferFbfToGroundCreate_H_
#define CrIaTransferFbfToGroundCreate_H_

/** FW Profile function definitions */
#include "FwProfile/FwPrConstants.h"

/** Action node identifiers */
#define CrIaTransferFbfToGround_N1 1		/* The identifier of action node N1 in procedure CrIaTransferFbfToGround */
#define CrIaTransferFbfToGround_N2 2		/* The identifier of action node N2 in procedure CrIaTransferFbfToGround */
#define CrIaTransferFbfToGround_N3 3		/* The identifier of action node N3 in procedure CrIaTransferFbfToGround */
#define CrIaTransferFbfToGround_N4 4		/* The identifier of action node N4 in procedure CrIaTransferFbfToGround */

/**
 * Create a new procedure descriptor.
 * This interface creates the procedure descriptor dynamically.
 * @param prData the pointer to the procedure data.
 * A value of NULL is legal (note that the default value of the pointer
 * to the procedure data when the procedure is created is NULL).
 * @return the pointer to the procedure descriptor
 */
FwPrDesc_t CrIaTransferFbfToGroundCreate(void* prData);

/**
 * Action for node N2.
 * <pre>
 * Start FBF Load Proc.
 * to load FBF identified by
 * FBF Counter into SDU4
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaTransferFbfToGroundN2(FwPrDesc_t prDesc);

/**
 * Action for node N3.
 * Start Down-Transfer of SDU4
 * @param smDesc the procedure descriptor
 */
void CrIaTransferFbfToGroundN3(FwPrDesc_t prDesc);

/**
 * Action for node N1.
 * <pre>
 * Set FBF Counter to identifier of
 * first FBF to be transferred to ground
 * </pre>
 * @param smDesc the procedure descriptor
 */
void CrIaTransferFbfToGroundN1(FwPrDesc_t prDesc);

/**
 * Action for node N4.
 * Increment FBF Counter
 * @param smDesc the procedure descriptor
 */
void CrIaTransferFbfToGroundN4(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from N2 to N3.
 * <pre>
 *  FBF Load Procedure
 * has completed 
 * </pre>
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaTransferFbfToGroundIsCompleted(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from N3 to DECISION1.
 *  Flag_1 
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaTransferFbfToGroundIsFlag1(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from DECISION1 to N4.
 * <pre>
 *  Number of images
 * transferred to ground
 * is smaller than pNmbImages 
 * </pre>
 * @param smDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t CrIaTransferFbfToGroundIsContinue(FwPrDesc_t prDesc);

#endif /* CrIaTransferFbfToGroundCreate_H_ */
